# CxJS

This is the main package of the [CxJS](https://cxjs.io/) framework.

Cx is a feature-rich framework for building data-oriented web applications.

Cx is inspired by React and Angular and tries to offer the best features from both worlds.
Out of the box, Cx provides:

-  a complete set of widgets
-  charts
-  two-way data-binding options
-  controllers
-  layouts
-  customizable appearance (Sass)

Cx is based on ES6 and JSX and requires `babel-plugin-transform-cx-jsx`.
Cx widgets use React to render and update the DOM.

### Getting Started

-  [Examples](https://cxjs.io/examples)
-  [Documentation](https://cxjs.io/docs)
-  [Themes](https://cxjs.io/themes)
-  [Fiddle](https://cxjs.io/fiddle)

## Demo Applications

<a href="https://cxjs.io/starter">
    <img src="https://raw.githubusercontent.com/codaxy/cx/master/misc/screenshots/starter/analytics.png" alt="Cx Starter Kit" height="200px" />
</a>
<a href="https://codaxy.github.io/state-of-js-2016-explorer/">
    <img src="https://raw.githubusercontent.com/codaxy/cx/master/misc/screenshots/sofjs2016/StateOfJs.png" alt="State of JS 2016 Explorer" height="200px" />
</a>
<a href="https://mstijak.github.io/tdo/">
    <img src="https://raw.githubusercontent.com/codaxy/cx/master/misc/screenshots/tdo/tdo.png" alt="Tdo" height="200px" />
</a>

### Installation

The easiest way to set up a new Cx project is to use
the [Cx Command Line Interface](https://cxjs.io/v/master/docs/intro/command-line).

### License

[MIT License](./LICENSE.md)
